package  {
	
	import flash.display.Sprite;

	public class Snake extends Sprite {
		
		private var tail:Array = [ ];
		
		public var dirI:int = -1;
		public var dirJ:int = 0;
		
		public function Snake() {
			
		}
		
		public function setHead(headI:Number, headJ:Number):void {
			var block:Block = new Block();
			block.i = headI;
			block.j = headJ;
			
			addChild(block);
			
			tail.unshift(block);
		}
		
		public function move(field:Field):Boolean {
			
			var head:Block = tail[0];
			
			var fruit:Fruit = field.fruit;
			
			//Съели фрукт
			if (fruit.i == head.i + dirI && fruit.j == head.j + dirJ) {
				
				var murderPlace:Block = new Block();
				
				murderPlace.i = fruit.i;
				murderPlace.j = fruit.j;
				
				addChild(murderPlace);
				tail.unshift(murderPlace);
				
				field.generateFruit();
				return true;
			}
			
			//Двигаем хвост
			var block:Block = tail.pop();
			
			var nextI:int = head.i + dirI;
			var nextJ:int = head.j + dirJ;
			
			if (isTouch(nextI, nextJ)) return false;
			
			block.i = nextI;
			block.j = nextJ;
			
			if (block.i >= field.maxI) block.i = 0;
			if (block.j >= field.maxJ) block.j = 0;
			
			if (block.i < 0) block.i =  field.maxI - 1;
			if (block.j < 0) block.j =  field.maxJ - 1;
			
			tail.unshift(block);
			return true;
		}
		

		
		public function setDir(dirI:Number, dirJ:Number):void {
			this.dirJ = dirJ;
			this.dirI = dirI;
		}
		
		public function isTouch(i:int, j:int):Boolean {
			
			for (var n:int = 0; n < tail.length; n++) {
				var block:Block = tail[n];
				if (block.i == i && block.j == j) return true;
			}
		
			return false;
		}
		
	}

}